package {
	import flash.display3D.Context3D;
	import flash.display3D.IndexBuffer3D;
	import flash.display3D.VertexBuffer3D;
	import flash.display3D.Context3DVertexBufferFormat;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;

	public class Box3D {
		
		private var vbBuffer:VertexBuffer3D;
		private var ibIndex:IndexBuffer3D;
		private var m3D:Matrix3D;
		private var nCount:int;

	public function Box3D(context:Context3D) {
			
            var triangles:Vector.<uint> = Vector.<uint>([
				2, 1, 0, //front face
				3, 2, 0,
				4, 7, 5, //bottom face
				7, 6, 5,
				8, 11, 9, //back face
				9, 11, 10,
				12, 15, 13, //top face
				13, 15, 14,
				16, 19, 17, //left face
				17, 19, 18,
				20, 23, 21, //right face
				21, 23, 22]);
            //Create vertex index list for the triangles forming a cube
			ibIndex = context.createIndexBuffer(triangles.length);
			ibIndex.uploadFromVector(triangles, 0, triangles.length);
			
			//Create vertexes - cube faces do not share vertexes
			const dataPerVertex:int = 6;
			var vertexData:Vector.<Number> = Vector.<Number>([
				// x,y,z r,g,b format
				0, 0, 0, 1, 0, 0, //front face
				0, 1, 0, 1, 0, 0,
				1, 1, 0, 1, 0, 0,
				1, 0, 0, 1, 0, 0,
				
				0, 0, 0, 0, 1, 0, //bottom face
				1, 0, 0, 0, 1, 0,
				1, 0, 1, 0, 1, 0,
				0, 0, 1, 0, 1, 0,
				
				0, 0, 1, 1, 0, 0, //back face
				1, 0, 1, 1, 0, 0,
				1, 1, 1, 1, 0, 0,
				0, 1, 1, 1, 0, 0,
				
				0, 1, 1, 0, 1, 0, //top face
				1, 1, 1, 0, 1, 0,
				1, 1, 0, 0, 1, 0,
				0, 1, 0, 0, 1, 0,
				
				0, 1, 1, 0, 0, 1, //left face
				0, 1, 0, 0, 0, 1,
				0, 0, 0, 0, 0, 1,
				0, 0, 1, 0, 0, 1,
				
				1, 1, 0, 0, 0, 1, //right face
				1, 1, 1, 0, 0, 1,
				1, 0, 1, 0, 0, 1,
				1, 0, 0, 0, 0, 1]);
			vbBuffer = context.createVertexBuffer(vertexData.length / dataPerVertex, dataPerVertex);
			vbBuffer.uploadFromVector(vertexData, 0, vertexData.length / dataPerVertex);
					
			m3D = new Matrix3D();
			nCount = 12;	
		}
				
		public function render(context:Context3D):void {
			context.setVertexBufferAt( 0, vbBuffer, 0, Context3DVertexBufferFormat.FLOAT_3 );
			context.setVertexBufferAt( 1, vbBuffer, 3, Context3DVertexBufferFormat.FLOAT_3 );
			context.drawTriangles(ibIndex, 0, nCount);
		}
				
		public function getMatrix3D():Matrix3D {return m3D;}

		
	}

}